Attribute VB_Name = "modACM"
Option Explicit

Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" ( _
        dest As Any, source As Any, ByVal dlen As Long)

Public Declare Function acmStreamPrepareHeader Lib "msacm32" (ByVal has As Long, _
        pash As ACMSTREAMHEADER, ByVal fdwPrepare As Long) As Long

Public Declare Function acmStreamUnprepareHeader Lib "msacm32" (ByVal has As Long, _
        pash As ACMSTREAMHEADER, ByVal fdwUnprepare As Long) As Long

Public Declare Function acmStreamOpen Lib "msacm32" (ByRef phas As Long, _
        ByVal had As Long, pwfxSrc As Any, pwfxDst As Any, ByVal pwfltr As Long, _
        ByVal dwCallback As Long, ByVal dwInstance As Long, ByVal fdwOpen As Long) As Long

Public Declare Function acmStreamSize Lib "msacm32" (ByVal has As Long, ByVal cbInput As Long, _
        pdwOutputBytes As Long, ByVal fdwSize As Long) As Long

Public Declare Function acmStreamConvert Lib "msacm32" (ByVal has As Long, _
        pash As ACMSTREAMHEADER, ByVal fdwConvert As Long) As Long

Public Declare Function acmStreamReset Lib "msacm32.dll" (ByVal has As Long, _
        ByVal fdwReset As Long) As Long

Public Declare Function acmStreamClose Lib "msacm32" (ByVal has As Long, _
        ByVal fdwClose As Long) As Long

Public Declare Function acmMetrics Lib "msacm32" (ByVal hao As Long, _
        ByVal uMetric As Integer, pMetric As Any) As Long

Public Declare Function acmDriverEnum Lib "msacm32" (ByVal fnCallback As Long, _
        dwInstance As Long, ByVal fdwEnum As Long) As Long

Public Declare Function acmDriverDetails Lib "msacm32" Alias "acmDriverDetailsA" ( _
        ByVal hadid As Long, padd As TACMDRIVERDETAILS, ByVal fdwDetails As Long) As Long

Public Declare Function acmDriverOpen Lib "msacm32" (ByRef phad As Long, _
        ByVal hadid As Long, ByVal fdwOpen As Long) As Long

Public Declare Function acmDriverClose Lib "msacm32" (ByVal had As Long, _
        ByVal fdwClose As Long) As Long

Public Declare Function acmFormatEnum Lib "msacm32" Alias "acmFormatEnumA" ( _
        ByVal had As Long, ByRef pafd As TACMFORMATDETAILS, ByVal fnCallback As Long, _
        ByRef dwInstance As Long, ByVal fdwEnum As ACM_FORMATENUMF) As Long

Public Declare Function acmFormatTagDetails Lib "msacm32" Alias "acmFormatTagDetailsA" ( _
        ByVal had As Long, paftd As TACMFORMATTAGDETAILS, ByVal fdwDetails As Long) As Long

Public Declare Function acmFormatDetails Lib "msacm32.dll" _
        Alias "acmFormatDetailsA" (ByVal had As Long, pafd As TACMFORMATDETAILS, _
        ByVal fdwDetails As Long) As Long

Public Declare Function acmFormatTagEnum Lib "msacm32.dll" _
        Alias "acmFormatTagEnumA" (ByVal had As Long, pafd As TACMFORMATTAGDETAILS, _
        ByVal fnCallback As Long, ByVal dwInstance As Long, ByVal fdwEnum As Long) As Long

Public Type TACMDRIVERDETAILS
    cbStruct                    As Long     ' size of the structure
    fccType(3)                  As Byte     ' driver type
    fccComp(3)                  As Byte     ' driver subtype
    wMid                        As Integer  ' manufacturer ID
    wPid                        As Integer  ' product ID
    vdwACM                      As Long     ' ACM version the driver was created with
    vdwDriver                   As Long     ' driver version
    fdwSupport                  As Long     ' Support Flags
    cFormatTags                 As Long     ' format tag count
    cFilterTags                 As Long     ' filter tag count
    hIcon                       As Long     ' driver icon
    szShortName(1 To 32)        As Byte     ' short description
    szLongName(1 To 128)        As Byte     ' long description
    szCopyright(1 To 80)        As Byte     ' copyright info
    szLicensing(1 To 128)       As Byte     ' license info
    szFeatures(1 To 512)        As Byte     ' features info
End Type

Public Type TACMFORMATDETAILS
    cbStruct                    As Long     ' size of the structure
    dwFormatIndex               As Long     ' format index
    dwFormatTag                 As Long     ' format tag
    fdwSupport                  As Long     ' support flags
    pwfx                        As Long     ' pointer to the WFX
    cbwfx                       As Long     ' size of the WFX
    szFormat(1 To 128)          As Byte     ' description
End Type

Public Type TACMFORMATTAGDETAILS
    cbStruct                    As Long     ' size of the structure
    dwFormatTagIndex            As Long     ' Format Tag Index
    dwFormatTag                 As Long     ' Format Tag
    cbFormatSize                As Long     ' WFX size
    fdwSupport                  As Long     ' Support Flags
    cStandardFormats            As Long     ' format count
    szFormatTag(1 To 128)       As Byte     ' tag description
End Type

Public Type ACMSTREAMHEADER
    cbStruct                    As Long     ' size of structure
    fdwStatus                   As Long     ' buffer status
    dwUser                      As Long     ' Userdata
    pbSrc                       As Long     ' source buffer pointer
    cbSrcLength                 As Long     ' source buffer size
    cbSrcLengthUsed             As Long     ' used part of source buffer
    dwSrcUser                   As Long     ' Userdata
    pbDst                       As Long     ' destination buffer pointer
    cbDstLength                 As Long     ' dest. buffer size
    cbDstLengthUsed             As Long     ' used part of dest. buffer
    dwDstUser                   As Long     ' Userdata
    dwReservedDriver(9)         As Long     ' reserved
End Type

Public Type WAVEFORMATEX
    wFormatTag                  As Integer  ' Format Tag
    nChannels                   As Integer  ' channel count
    nSamplesPerSec              As Long     ' Samples/Second
    nAvgBytesPerSec             As Long     ' Bytes/Second
    nBlockAlign                 As Integer  ' Block Align
    wBitsPerSample              As Integer  ' Bits/Sample
    cbSize                      As Integer  ' size of xBytes
    xBytes(11)                  As Byte     ' extra data
End Type

Public Enum ACM_FCCTYPE
    ACMDRIVERDETAILS_FCCTYPE_AUDIOCODEC = &H61756463
    ACMDRIVERDETAILS_FCCCOMP_UNDEFINED = &H0
End Enum

Public Enum ACM_WAVE_FORMAT
    WAVE_FORMAT_UNKNOWN = &H0
    WAVE_FORMAT_PCM = &H1
    WAVE_FORMAT_MPEGLAYER3 = &H55
End Enum

Public Enum ACM_METRICS
    ACM_METRIC_COUNT_DRIVERS = 1
    ACM_METRIC_COUNT_CODECS = 2
    ACM_METRIC_COUNT_CONVERTERS = 3
    ACM_METRIC_COUNT_FILTERS = 4
    ACM_METRIC_COUNT_DISABLED = 5
    ACM_METRIC_COUNT_HARDWARE = 6
    ACM_METRIC_COUNT_LOCAL_DRIVERS = 20
    ACM_METRIC_COUNT_LOCAL_CODECS = 21
    ACM_METRIC_COUNT_LOCAL_CONVERTERS = 22
    ACM_METRIC_COUNT_LOCAL_FILTERS = 23
    ACM_METRIC_COUNT_LOCAL_DISABLED = 24
    ACM_METRIC_HARDWARE_WAVE_INPUT = 30
    ACM_METRIC_HARDWARE_WAVE_OUTPUT = 31
    ACM_METRIC_MAX_SIZE_FORMAT = 50
    ACM_METRIC_MAX_SIZE_FILTER = 51
    ACM_METRIC_DRIVER_SUPPORT = 100
    ACM_METRIC_DRIVER_PRIORITY = 101
End Enum

Public Enum ACM_STREAMCONVERTF
    ACM_STREAMCONVERTF_BLOCKALIGN = &H4
    ACM_STREAMCONVERTF_START = &H10
    ACM_STREAMCONVERTF_END = &H20
End Enum

Public Enum ACM_STREAMHEADER_STATUSF
    ACMSTREAMHEADER_STATUSF_DONE = &H10000
    ACMSTREAMHEADER_STATUSF_PREPARED = &H20000
    ACMSTREAMHEADER_STATUSF_INQUEUE = &H100000
End Enum

Public Enum ACM_STREAMOPENF
    ACM_STREAMOPENF_QUERY = &H1
    ACM_STREAMOPENF_ASYNC = &H2
    ACM_STREAMOPENF_NONREALTIME = &H4
End Enum

Public Enum ACM_STREAMSIZEF
    ACM_STREAMSIZEF_DESTINATION = &H1&
    ACM_STREAMSIZEF_SOURCE = &H0&
    ACM_STREAMSIZEF_QUERYMASK = &HF&
End Enum

Public Enum ACM_DRIVERENUMF
    ACM_DRIVERENUMF_NOLOCAL = &H40000000
    ACM_DRIVERENUMF_DISABLED = &H80000000
End Enum

Public Enum ACM_FORMATENUMF
    ACM_FORMATENUMF_WFORMATTAG = &H10000
    ACM_FORMATENUMF_NCHANNELS = &H20000
    ACM_FORMATENUMF_NSAMPLESPERSEC = &H40000
    ACM_FORMATENUMF_WBITSPERSAMPLE = &H80000
    ACM_FORMATENUMF_CONVERT = &H100000
    ACM_FORMATENUMF_SUGGEST = &H200000
    ACM_FORMATENUMF_HARDWARE = &H400000
    ACM_FORMATENUMF_INPUT = &H800000
    ACM_FORMATENUMF_OUTPUT = &H1000000
End Enum

Public Enum ACM_FORMATTAGDETAILS
    ACM_FORMATTAGDETAILSF_INDEX = &H0&
    ACM_FORMATTAGDETAILSF_FORMATTAG = &H1&
    ACM_FORMATTAGDETAILSF_LARGESTSIZE = &H2&
    ACM_FORMATTAGDETAILSF_QUERYMASK = &HF&
End Enum

Public Enum ACM_DRIVERDETAILS
    ACMDRIVERDETAILS_SUPPORTF_ASYNC = &H10&
    ACMDRIVERDETAILS_SUPPORTF_CODEC = &H1&
    ACMDRIVERDETAILS_SUPPORTF_LOCAL = &H40000000
    ACMDRIVERDETAILS_SUPPORTF_FILTER = &H4&
    ACMDRIVERDETAILS_SUPPORTF_HARDWARE = &H8&
    ACMDRIVERDETAILS_SUPPORTF_DISABLED = &H80000000
    ACMDRIVERDETAILS_SUPPORTF_CONVERTER = &H2&
End Enum

Public Enum ACM_CALLBACKS
    CALLBACK_NULL = &H0&
    CALLBACK_EVENT = &H50000
    CALLBACK_WINDOW = &H10000
    CALLBACK_THREAD = &H20000
    CALLBACK_TYPEMASK = &H70000
    CALLBACK_FUNCTION = &H30000
End Enum

Public Enum ACM_STATUS
    MM_STREAM_OPEN = &H3D4
    MM_STREAM_CLOSE = &H3D5
    MM_STREAM_DONE = &H3D6
    MM_STREAM_ERROR = &H3D7
End Enum

Public Enum ACM_ERRORS
    ACMERR_BUSY = &H201&
    ACMERR_CANCELED = &H203&
    ACMERR_UNPREPARED = &H202&
    ACMERR_NOTPOSSIBLE = &H200&
End Enum

Public Enum MMSYS_ERRORS
    MMSYSERR_NOERROR = 0
    MMSYSERR_ERROR = 1
    MMSYSERR_BADDEVICEID = 2
    MMSYSERR_NOTENABLED = 3
    MMSYSERR_ALLOCATED = 4
    MMSYSERR_INVALHANDLE = 5
    MMSYSERR_NODRIVER = 6
    MMSYSERR_NOMEM = 7
    MMSYSERR_NOTSUPPORTED = 8
    MMSYSERR_BADERRNUM = 9
    MMSYSERR_INVALFLAG = 10
    MMSYSERR_INVALPARAM = 11
    MMSYSERR_HANDLEBUSY = 12
    MMSYSERR_INVALIDALIAS = 13
    MMSYSERR_BADDB = 14
    MMSYSERR_KEYNOTFOUND = 15
    MMSYSERR_READERROR = 16
    MMSYSERR_WRITEERROR = 17
    MMSYSERR_DELETEERROR = 18
    MMSYSERR_VALNOTFOUND = 19
    MMSYSERR_NODRIVERCB = 20
End Enum

'************** Driver/Codec Collection
Public Type ACM_Format
    detail      As TACMFORMATDETAILS
    wfx(99)     As Byte
End Type

Public Type ACM_FormatTag
    detail      As TACMFORMATTAGDETAILS
    formats()   As ACM_Format
    formatcount As Integer
End Type

Public Type ACM_Driver
    haid        As Long
    handle      As Long
    detail      As TACMDRIVERDETAILS
    tags()      As ACM_FormatTag
    tagcount    As Integer
End Type

Public Type ACM_Codecs
    drivers()   As ACM_Driver
    count       As Integer
End Type
Public codecs   As ACM_Codecs
'*********************************

Public Function ACMEnumCodecs() As Boolean
    ' reset codec collection
    ReDim codecs.drivers(0)
    codecs.count = 0

    ' get all codecs
    ACMEnumCodecs = MMSYSERR_NOERROR = acmDriverEnum(AddressOf acmDriverEnumCallback, 0, 0)
End Function

Public Function acmDriverEnumCallback(ByVal haid As Long, _
                                      ByVal dwInstance As Long, _
                                      ByVal fdwSupport As Long) As Long

    Dim hDriver         As Long
    Dim mmr             As Long
    Dim wfx(99)         As Byte
    Dim udtDriverDet    As TACMDRIVERDETAILS
    Dim udtFmtTag       As TACMFORMATTAGDETAILS

    ' get driver details
    udtDriverDet.cbStruct = LenB(udtDriverDet)
    mmr = acmDriverDetails(haid, udtDriverDet, 0)

    ' save driver details to codec collection
    If mmr = MMSYSERR_NOERROR Then
        With codecs
            .drivers(.count).haid = haid
            .drivers(.count).detail = udtDriverDet
        End With
    End If

    mmr = acmDriverOpen(hDriver, haid, 0)
    If mmr = MMSYSERR_NOERROR Then

        With codecs
            .drivers(.count).handle = hDriver
        End With

        ' enumerate all format tags of the driver
        udtFmtTag.cbStruct = Len(udtFmtTag)
        mmr = acmFormatTagEnum(hDriver, udtFmtTag, AddressOf acmFormatTagEnumCallback, 0, 0)

        With codecs.drivers(codecs.count)
            .tagcount = .tagcount + 1
        End With

        acmDriverClose hDriver, 0
    End If

    codecs.count = codecs.count + 1
    ReDim Preserve codecs.drivers(codecs.count)

    acmDriverEnumCallback = 1
End Function

Public Function acmFormatEnumCallback(ByVal had As Long, _
                                      ByVal pafd As Long, _
                                      ByVal dwInstance As Long, _
                                      ByVal fdwSupport As Long) As Long

    Dim udtFmtDet       As TACMFORMATDETAILS
    Dim udtFmtTagDet    As TACMFORMATTAGDETAILS
    Dim mmr             As Long
    Dim wfx             As WAVEFORMATEX

    CopyMemory udtFmtDet, ByVal pafd, Len(udtFmtDet)
    CopyMemory wfx, ByVal udtFmtDet.pwfx, Len(wfx)

    ' only enum formats which fit to the
    ' current format tag
    If wfx.wFormatTag <> dwInstance Then
        acmFormatEnumCallback = 1
        Exit Function
    End If

    With codecs
        With .drivers(.count)
            With .tags(.tagcount)
                ReDim Preserve .formats(.formatcount)

                ' save format details and WAVEFORMATEX structure
                With .formats(.formatcount)
                    .detail = udtFmtDet
                    CopyMemory .wfx(0), ByVal udtFmtDet.pwfx, udtFmtDet.cbwfx
                End With

                .formatcount = .formatcount + 1
            End With
        End With
    End With

    acmFormatEnumCallback = 1
End Function

Public Function acmFormatTagEnumCallback(ByVal haid As Long, _
                        ByVal pafd As Long, _
                        ByVal dwInstance As Long, _
                        ByVal fdwSupport As Long) As Long

    Dim udtFmtTag   As TACMFORMATTAGDETAILS
    Dim udtFmtDet   As TACMFORMATDETAILS
    Dim mmr         As Long
    Dim wfx(99)     As Byte

    CopyMemory udtFmtTag, ByVal pafd, Len(udtFmtTag)

    With codecs.drivers(codecs.count)

        ReDim Preserve .tags(.tagcount)

        .tags(.tagcount).detail = udtFmtTag

        ' prepare formatdetails struct
        With udtFmtDet
            .cbStruct = Len(udtFmtDet)
            .dwFormatTag = WAVE_FORMAT_UNKNOWN
            .pwfx = VarPtr(wfx(0))
            .cbwfx = UBound(wfx) + 1
        End With

        ' enum all formats of the format tag
        mmr = acmFormatEnum(.handle, udtFmtDet, _
                            AddressOf acmFormatEnumCallback, _
                            ByVal udtFmtTag.dwFormatTag, 0)

        .tagcount = .tagcount + 1

    End With

    acmFormatTagEnumCallback = 1
End Function


