Attribute VB_Name = "modWAV"
Option Explicit

Public Type WAV_Hdr
    RIFF                As String * 4
    filesize            As Long
    WAVEfmt             As String * 8
    fmtlen              As Long
    formattag           As Integer
    channels            As Integer
    sps                 As Long
    bpsec               As Long
    bla                 As Integer
    bps                 As Integer
    data                As String * 4
    datalen             As Long
End Type

Private Type mmioinfo
   dwFlags              As Long
   fccIOProc            As Long
   pIOProc              As Long
   wErrorRet            As Long
   htask                As Long
   cchBuffer            As Long
   pchBuffer            As String
   pchNext              As String
   pchEndRead           As String
   pchEndWrite          As String
   lBufOffset           As Long
   lDiskOffset          As Long
   adwInfo(4)           As Long
   dwReserved1          As Long
   dwReserved2          As Long
   hmmio                As Long
End Type

Private Type MMCKINFO
   ckid                 As Long
   ckSize               As Long
   fccType              As Long
   dwDataOffset         As Long
   dwFlags              As Long
End Type

Public Type ChunkInfo
    Start               As Long
    length              As Long
End Type


Private Const MMIO_READ         As Long = &H0
Private Const MMIO_FINDCHUNK    As Long = &H10
Private Const MMIO_FINDRIFF     As Long = &H20

Private Const SEEK_CUR          As Long = 1


Private Declare Function mmioClose Lib "winmm.dll" ( _
        ByVal hmmio As Long, _
        ByVal uFlags As Long) As Long

Private Declare Function mmioDescend Lib "winmm.dll" ( _
        ByVal hmmio As Long, _
        lpck As MMCKINFO, _
        lpckParent As MMCKINFO, _
        ByVal uFlags As Long) As Long

Private Declare Function mmioDescendParent Lib "winmm.dll" _
Alias "mmioDescend" ( _
        ByVal hmmio As Long, _
        lpck As MMCKINFO, _
        ByVal X As Long, _
        ByVal uFlags As Long) As Long

Private Declare Function mmioOpen Lib "winmm.dll" _
Alias "mmioOpenA" ( _
        ByVal szFileName As String, _
        lpmmioinfo As mmioinfo, _
        ByVal dwOpenFlags As Long) As Long

Private Declare Function mmioSeek Lib "winmm.dll" ( _
        ByVal hmmio As Long, _
        ByVal lOffset As Long, _
        ByVal iOrigin As Long) As Long

Private Declare Function mmioStringToFOURCC Lib "winmm.dll" _
Alias "mmioStringToFOURCCA" ( _
        ByVal sz As String, _
        ByVal uFlags As Long) As Long

Public Function GetWavChunkPos( _
    ByVal strFile As String, _
    ByVal strChunk As String _
) As ChunkInfo

    Dim hMmioIn             As Long
    Dim lR                  As Long
    Dim mmckinfoParentIn    As MMCKINFO
    Dim mmckinfoSubchunkIn  As MMCKINFO
    Dim mmioinf             As mmioinfo

    ' open WAV for read access
    hMmioIn = mmioOpen(strFile, mmioinf, MMIO_READ)
    If hMmioIn = 0 Then
        Exit Function
    End If

    ' check if it is really a WAV
    mmckinfoParentIn.fccType = mmioStringToFOURCC("WAVE", 0)
    lR = mmioDescendParent(hMmioIn, mmckinfoParentIn, 0, MMIO_FINDRIFF)
    If Not (lR = MMSYSERR_NOERROR) Then
        mmioClose hMmioIn, 0
       Exit Function
    End If

    ' search for the requested chunk
    mmckinfoSubchunkIn.ckid = mmioStringToFOURCC(strChunk, 0)
    lR = mmioDescend(hMmioIn, mmckinfoSubchunkIn, mmckinfoParentIn, MMIO_FINDCHUNK)
    If Not (lR = MMSYSERR_NOERROR) Then
        mmioClose hMmioIn, 0
        Exit Function
    End If

    ' return startpos and length of the chunk
    GetWavChunkPos.Start = mmioSeek(hMmioIn, 0, SEEK_CUR)
    GetWavChunkPos.length = mmckinfoSubchunkIn.ckSize

    mmioClose hMmioIn, 0
End Function
